// The sample contained herein is provided to you "AS IS".
//
// It is furnished by Add-in Express as a simple example and has not been
// thoroughly tested under all conditions. Add-in Express, therefore, cannot
// guarantee its reliability, serviceability or functionality.

unit ContextDependentAETPD7_IMPL;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Office2000, adxAddIn, ContextDependentAETPD7_TLB, StdVcl,
  adxHostAppEvents, Classes, adxxlFormsManager, Excel2000, Unit1;

type
  TCoContextDependentAETPD7 = class(TadxAddin, ICoContextDependentAETPD7)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    adxExcelTaskPanesManager1: TadxExcelTaskPanesManager;
    adxExcelAppEvents1: TadxExcelAppEvents;
    procedure adxExcelAppEvents1SheetActivate(ASender: TObject;
      const Sh: IDispatch);
    procedure adxExcelAppEvents1SheetChange(ASender: TObject;
      const Sh: IDispatch; const Target: ExcelRange);
  private
    function GetTaskPane: TadxExcelTaskPane1;
  private
    function GetA1Cell: ExcelRange;
    function GetA1Text: string;
    procedure SetA1Text(const Value: string);
    procedure CheckContextAndProcessTaskPaneShowing();
    procedure UpdateTaskPane(); 
    property TaskPane: TadxExcelTaskPane1 read GetTaskPane;
  protected
  public
    property A1Cell: ExcelRange read GetA1Cell;
    property A1Text: string read GetA1Text write SetA1Text;
    function IsNecessaryShowTaskPane(): boolean;
  end;

implementation



{$R *.dfm}

procedure TAddInModule.adxExcelAppEvents1SheetActivate(ASender: TObject;
  const Sh: IDispatch);
begin
  CheckContextAndProcessTaskPaneShowing();
  UpdateTaskPane();
end;

procedure TAddInModule.adxExcelAppEvents1SheetChange(ASender: TObject;
  const Sh: IDispatch; const Target: ExcelRange);
begin
  CheckContextAndProcessTaskPaneShowing();
  UpdateTaskPane();
end;

procedure TAddInModule.CheckContextAndProcessTaskPaneShowing;
begin
  if (Self.TaskPane <> nil) then begin
    if ((Self.TaskPane.Visible) and not IsNecessaryShowTaskPane()) then begin
      Self.TaskPane.Hide();
    end;

    if ((not Self.TaskPane.Visible) and IsNecessaryShowTaskPane()) then begin
      //Also see the TadxExcelTaskPane1.OnADXBeforeTaskPaneShow event
      Self.TaskPane.Show();
    end;
  end;
end;

function TAddInModule.GetA1Cell: ExcelRange;
var
  activeWorksheet: ExcelWorksheet;
  range: ExcelRange;
begin
  range := nil;
  activeWorksheet := Self.ExcelApp.ActiveSheet as ExcelWorksheet;
  try
    if (activeWorksheet <> nil) then begin
      range := activeWorksheet.Range['A1', 'A1'];
    end;
    result := range;
  finally
    activeWorksheet := nil;
  end;
end;

function TAddInModule.GetA1Text: string;
begin
  result := '';
  if (A1Cell <> nil) then begin
    result := A1Cell.Text;
  end;
end;

function TAddInModule.GetTaskPane: TadxExcelTaskPane1;
var
  taskPane: TadxExcelTaskPane;
begin
  taskPane := adxExcelTaskPanesManager1.Items[0].TaskPaneInstance;

  if (taskPane = nil) then begin
    taskPane := adxExcelTaskPanesManager1.Items[0].CreateTaskPaneInstance();
  end;

  result := taskPane as TadxExcelTaskPane1;
end;

function TAddInModule.IsNecessaryShowTaskPane: boolean;
begin
  result := length(A1Text) > 0;
end;

procedure TAddInModule.SetA1Text(const Value: string);
begin
  if (A1Cell <> nil) then begin
    A1Cell.Value2 := Value;
  end;
end;

procedure TAddInModule.UpdateTaskPane;
begin
  if (Self.TaskPane <> nil) then begin
    Self.TaskPane.A1CellMirror := A1Text;
  end;
end;

initialization
  TadxFactory.Create(ComServer, TCoContextDependentAETPD7, CLASS_CoContextDependentAETPD7, TAddInModule);

end.
