// The sample contained herein is provided to you "AS IS".
//
// It is furnished by Add-in Express as a simple example and has not been
// thoroughly tested under all conditions. Add-in Express, therefore, cannot
// guarantee its reliability, serviceability or functionality.

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Excel2000, adxxlFormsManager, StdCtrls;

type
  TadxExcelTaskPane1 = class(TadxExcelTaskPane)
    Label1: TLabel;
    Edit1: TEdit;
    procedure adxExcelTaskPaneCreate(Sender: TObject);
    procedure adxExcelTaskPaneADXBeforeTaskPaneShow(ASender: TObject;
      Args: TadxBeforeTaskPaneShowEventArgs);
    procedure Edit1Change(Sender: TObject);
  private
    isA1CellMirrorSetting: boolean;
    function GetA1CellMirror: string;
    procedure SetA1CellMirror(const Value: string);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    property A1CellMirror: string read GetA1CellMirror write SetA1CellMirror; 
  published
    { Published declarations }
  end;

{NOTE: The adxExcelTaskPane1 variable is intended for the exclusive use
       by the TadxExcelTaskPanesCollectionItem Designer.
       NEVER use this variable for other purposes.}
var
  adxExcelTaskPane1 : TadxExcelTaskPane1;

implementation

uses ContextDependentAETPD7_IMPL;

{$R *.DFM}

{ TadxExcelTaskPane1 }

function TadxExcelTaskPane1.GetA1CellMirror: string;
begin
  result := Edit1.Text;
end;

procedure TadxExcelTaskPane1.SetA1CellMirror(const Value: string);
begin
  isA1CellMirrorSetting := true;
  try
    Edit1.Text := Value;
  finally
    isA1CellMirrorSetting := false;
  end;
end;

procedure TadxExcelTaskPane1.adxExcelTaskPaneCreate(Sender: TObject);
begin
  isA1CellMirrorSetting := false;
end;

procedure TadxExcelTaskPane1.adxExcelTaskPaneADXBeforeTaskPaneShow(
  ASender: TObject; Args: TadxBeforeTaskPaneShowEventArgs);
begin
  Self.Visible := (AddinModule as TAddInModule).IsNecessaryShowTaskPane();
end;

procedure TadxExcelTaskPane1.Edit1Change(Sender: TObject);
begin
  if (not isA1CellMirrorSetting) then begin
    (AddinModule as TAddinModule).A1Text := A1CellMirror;
  end;
end;

initialization
  RegisterClass(TPersistentClass(TadxExcelTaskPane1));

finalization
end.
